// Fix for VIBEROID-1136 (Same Origin issues for Yahoo videos)
// Explicitly set domain with no protocol (no http/https)
var domain = document.domain;
var imageNodes = [];
domain = domain.substring(domain.indexOf(':') + 1, urlLength);
document.domain = domain;

var allTags = document.getElementsByTagName('*');
var instaEmbed = 'instagram-media';
var twitterEmbed = 'twitter-tweet';

var loadInstaEmbed = false;
var loadTwitterEmbed = false;

for (var i = 0; i < allTags.length; i++) {
    var curentTag = allTags[i];

    if (curentTag.className === instaEmbed) {
        loadInstaEmbed = true;
    } else if (curentTag.className === twitterEmbed) {
        loadTwitterEmbed = true;
    } else {
        // add to imageNodes
        if (curentTag.tagName === "IMG") {
            imageNodes.push(curentTag);
        }
        allTags[i].removeAttribute('style');
    }
}

// fixing instagram + twitter embeds by including their respective scripts
if (loadInstaEmbed) {
    var instaEmbedScript = document.createElement('script');
    instaEmbedScript.setAttribute('src', '//platform.instagram.com/en_US/embeds.js');
    instaEmbedScript.setAttribute("async", "");
    instaEmbedScript.setAttribute("defer", "");
    document.getElementsByTagName('head')[0].appendChild(instaEmbedScript);
}

if (loadTwitterEmbed) {
    var twitterEmbedScript = document.createElement('script');
    twitterEmbedScript.setAttribute('src', '//platform.twitter.com/widgets.js');
    twitterEmbedScript.setAttribute("async", "");
    document.getElementsByTagName('head')[0].appendChild(twitterEmbedScript);
}

var iFrames = document.getElementsByTagName('iframe');

for (var j = 0; j < iFrames.length; j++) {
    var iframeNode = iFrames[j];
    var iframeUrl = iframeNode.src;
    var urlLength = iframeUrl.length;


    if (iframeUrl.substring(0, 7) === 'file://') {
        iframeUrl = 'http://' + iframeUrl.substring(7, urlLength);
        iframeNode.src = iframeUrl;
    }

    // Handle incorrect protocol (See HOMERUNAND-1035)
    var protocolLength = getProtocolLength(iframeUrl);
    if (protocolLength == 4 && iframeUrl.substring(0, protocolLength) !== 'http') {
        iframeUrl = 'http' + iframeUrl.substring(protocolLength, urlLength);
        iframeNode.src = iframeUrl;
    } else if (protocolLength == 5 && iframeUrl.substring(0, protocolLength) !== 'https') {
        iframeUrl = 'https' + iframeUrl.substring(protocolLength, urlLength);
        iframeNode.src = iframeUrl;
    }

    // Resize fixed width/height proportionally to fix device width
    var sizeRatio = 0;
    if (iframeNode.getAttribute('data-yahoo-uuid')) {
        // Assume this is a 16:9 video
        sizeRatio = 0.5625;
    } else if (iframeNode.width && iframeNode.height) {
        sizeRatio = iframeNode.height / iframeNode.width;
    }

    if (sizeRatio) {
        iframeNode.style.position = 'absolute';
        iframeNode.width = '100% !important';
        iframeNode.height = '100% !important';
        iframeNode.style.left = '0px';
        iframeNode.style.top = '0px';

        var iframeWrapper = document.createElement('div');
        iframeWrapper.className = 'hr-iframe-wrapper';
        iframeWrapper.style.position = 'relative';
        iframeWrapper.width = '100% !important';
        iframeWrapper.height = '0px';
        iframeWrapper.style.paddingBottom = (sizeRatio * 100) + '%';

        var parent = iframeNode.parentNode;
        parent.replaceChild(iframeWrapper, iframeNode);
        iframeWrapper.appendChild(iframeNode);
    } else {
        iframeNode.width = '100% !important';
        iframeNode.height = 'auto';
    }

    if (iframeNode.src.includes('embed.scribblelive.com/Embed/v7')) {
        iframeNode.height = '0px';
        iframeWrapper.style.paddingBottom = '0px';
    }

    // Enable fullscreen toggle
    iframeNode.setAttribute('allowFullScreen', '');
}

function getProtocolLength(url) {
    var length = 0;
    for (var i = 0; i < url.length; i++) {
        if (url.charAt(i) == ':') {
            length = i;
            break;
        }
    }
    return length;
}
// Handle removing images which failed to load
(function() {
    var imagesArray = imageNodes.length ? imageNodes : Array.prototype.slice.call(document.getElementsByTagName('img'));
    var loadImage = function loadImage(imageToLoad, index) {
        var src = imageToLoad.getAttribute('src');
        var img = new Image();

        // dont remove src from first image
        if (index !== 0) {
            imageToLoad.setAttribute('src', '');
        }
        img.addEventListener('error', function(e) {
            // remove node if image fails to load
            imageToLoad.parentNode.removeChild(imageToLoad);
        });
        img.addEventListener('load', function(e) {
            imageToLoad.setAttribute('src', src);
        });
        img.src = src;
    };
    for (var i = 0; i < imagesArray.length; i++) {
        loadImage(imagesArray[i], i);
    }
 })();
